//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "RtfHtmlImage0.h"
#include <JPEG.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
AnsiString fRTF, fHTML;

void JpgToBmp(TImage *image)
{ Graphics::TBitmap *bmp = new Graphics::TBitmap();

  bmp->Width  = image->Picture->Width;
  bmp->Height = image->Picture->Height;
  bmp->Canvas->Draw(0,0,image->Picture->Graphic);
  image->Picture->Bitmap->Assign(bmp);
  image->Refresh();

  delete bmp;
}

void toBinary(TImage *image, int threshold=128)
{ Byte **ptr;
  int r, g, b, gray, index;

  image->Picture->Bitmap->PixelFormat = pf24bit;
  ptr = new Byte*[image->Picture->Height];
  for (int k=0; k<image->Picture->Height; k++)
     ptr[k] = (Byte*) image->Picture->Bitmap->ScanLine[k];
  for (int row=0; row<image->Picture->Height; row++)
     { index = 0;
       for (int col=0; col<image->Picture->Width; col++)
          { b = ptr[row][index  ];
            g = ptr[row][index+1];
            r = ptr[row][index+2];
            gray = 0.299*r + 0.587*g + 0.114*b;
            if ( gray>=threshold ) gray = 255;
            else gray = 0;
            ptr[row][index  ] = (Byte)gray;
            ptr[row][index+1] = (Byte)gray;
            ptr[row][index+2] = (Byte)gray;
            index += 3;
          }
     }
  delete [] ptr;
}
void shrink(Graphics::TBitmap *bmp, float sx, float sy)
{ int x, y, px, py, bkx, bky, h, w;
  int mWidth, mHeight;
  unsigned long index;
  float value;
  BYTE *ptr, *pImg;
  Graphics::TBitmap *mBmp = new Graphics::TBitmap();

  mBmp->Assign(bmp);  // ƥ
  mBmp->PixelFormat = pf24bit;
  
  w = mBmp->Width * sx;  // pYϤؤo
  h = mBmp->Height* sy;
  bmp->Width  = w;
  bmp->Height = h;
  bmp->PixelFormat = pf24bit;

  mWidth  = mBmp->Width;
  mHeight = mBmp->Height;
  
  sx = 1.0/sx;  sy = 1.0/sy;
  unsigned long idxImg=0L;
  int gray[3];
  for (py=0; py<h; py++)
     { pImg = (Byte *) bmp->ScanLine[py];
       for (px=0; px<w; px++)
  	  { x = px*sx;
            y = py*sy;
            idxImg = y*mWidth+x;

            gray[0]=gray[1]=gray[2]=0;
            for (bky=0; bky<sy; bky++)  // o϶C⪺
               { ptr = (Byte *) mBmp->ScanLine[y+bky];
                 for (bkx=0; bkx<sx; bkx++)
                    { gray[0] += ptr[3*(x+bkx)  ];
                      gray[1] += ptr[3*(x+bkx)+1];
                      gray[2] += ptr[3*(x+bkx)+2];
                    }
               }
            for (int k=0; k<3; k++) gray[k] /= (bkx*bky);
            pImg[3*px  ] = gray[0];
            pImg[3*px+1] = gray[1];
            pImg[3*px+2] = gray[2];
  	  }
     }
}

void __fastcall TForm1::bitnHTMLTextImageClick(TObject *Sender)
{
  Screen->Cursor = crHourGlass;

  JpgToBmp(Image1);
  float sw, sh, sx, sy, scale, len=87.;

  sw = Image1->Picture->Width;
  sh = Image1->Picture->Height;
  sx = len / sw;
  sy = len / sh;
  if ( sx<sy ) scale = sx; else scale = sy;

  shrink(Image1->Picture->Bitmap, scale*2.24*0.93, scale*0.85);
  //Memo2->Lines->Clear();

  Byte *ptr;
  int w, h, index,sum,z;
  AnsiString line;
  TStringList *textImage = new TStringList();

  w = Image1->Picture->Width;
  h = Image1->Picture->Height;

  Image1->Picture->Bitmap->PixelFormat = pf24bit;
  textImage->Add("<HTML>\n<BODY bgcolor=#000000>\n<center><pre><font size=0.5>");
  for (int y=0; y<h; y++)
     { ptr = (unsigned char *) Image1->Picture->Bitmap->ScanLine[y];
       index = 0;
       line = "";
       for (int x=0; x<w; x++)
          { line += "<font color=#";
            line += IntToHex(ptr[index+2], 2);
            line += IntToHex(ptr[index+1], 2);
            line += IntToHex(ptr[index  ], 2);
            //line.cat_printf(">%c</font>", random(2)+48);  // 0-1 case
            //line.cat_printf(">%c</font>", random(80)+33 );  // arbitrary char
            line.cat_printf(">%c</font>", '$' );
            index += 3;
          }
       //line += "\n";
       textImage->Add(line);
     }
  //RichEdit1->Lines->Assign(textImage);
  textImage->Add("</font></pre></center></body></HTML>");
  SaveDialog1->Filter = "*.html|*.html";;
  SaveDialog1->DefaultExt = ".html";
  if ( SaveDialog1->Execute() )
    { bool saveIt=true;
      if ( FileExists(SaveDialog1->FileName) )
        { int ans = MessageDlg(SaveDialog1->FileName+" exists, overwirte it?",
                           mtWarning, TMsgDlgButtons() << mbYes << mbNo, 0);
          if ( ans!=mrYes ) saveIt = false;
        }
      if ( saveIt )
        { textImage->SaveToFile(SaveDialog1->FileName);
          ShowMessage("File has saved!");
        };
      fHTML = SaveDialog1->FileName;
    }

  delete textImage;

  Screen->Cursor = crDefault;
}

void __fastcall TForm1::bitnColorTextImageClick(TObject *Sender)
{
  JpgToBmp(Image1);
  float sw, sh, sx, sy, scale, len=120;

  sw = Image1->Picture->Width;
  sh = Image1->Picture->Height;
  if ( sw==0 || sh==0 )
    { ShowMessage("Load Image file first (.jpg/.bmp)! ");
      return;
    }
  sx = len / sw;
  sy = len / sh;
  if ( sx<sy ) scale = sx; else scale = sy;

  //shrink(Image1->Picture->Bitmap, scale*2.24*0.93, scale*0.85);
  shrink(Image1->Picture->Bitmap, scale*2.64, scale*0.825);
  //shrink(Image1->Picture->Bitmap, scale, scale); // for '@'

  Byte *ptr;
  int w, h;
  TStringList *lst = new TStringList();
  AnsiString line;

  RichEdit1->Font->Size = 1;
  
  w = Image1->Picture->Width;
  h = Image1->Picture->Height;

  Screen->Cursor = crHourGlass;

  for (int k=1; k<=w; k++) line.Insert("$",1); //"#","$","@"
  ///* fast
  for (int k=0; k<h; k++) lst->Add(line);
  RichEdit1->Lines->Assign(lst);
  //*/
  //for (int k=0; k<h; k++) RichEdit1->Lines->Add(line); // slow

  int index = 0, idxImage, gray=5;
  Image1->Picture->Bitmap->PixelFormat = pf24bit;
  RichEdit1->Color = RGB(gray, gray, gray);
  RichEdit1->SelLength = 1;
  for (int r=0; r<h; r++)
     { ptr = (Byte*) Image1->Picture->Bitmap->ScanLine[r];
       idxImage = 0;
       for (int c=0; c<w; c++)
          { RichEdit1->SelStart = index;
            RichEdit1->SelLength = 1;
            RichEdit1->SelAttributes->Color = (TColor) RGB(ptr[idxImage+2], ptr[idxImage+1], ptr[idxImage]);
            idxImage += 3;
            index++; // next char
          }
       index += 2;  // next line
     }
  delete lst;

  Screen->Cursor = crDefault;
}

//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  Form1->DoubleBuffered = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Load1Click(TObject *Sender)
{
  OpenDialog1->Filter   = "*.bmp;*.jpg|*.bmp;*.jpg";
  OpenDialog1->FileName = "";
  if ( OpenDialog1->Execute() )
    { Image1->Picture->LoadFromFile(OpenDialog1->FileName);
      Image1->Top  = 1;
      Image1->Left = 1;
      Graphics::TBitmap *bmp = new Graphics::TBitmap();
      bmp->Width  = Image1->Picture->Width;
      bmp->Height = Image1->Picture->Height;
      bmp->Canvas->Draw(0,0,Image1->Picture->Graphic);
      Image1->Picture->Bitmap->Assign(bmp);
      Image1->Refresh();
      delete bmp;
    }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::bitnShowHTMLClick(TObject *Sender)
{ OpenDialog1->Filter   = "*.htm;*.html|*.htm;*.html";
  OpenDialog1->FileName = fHTML;
  if ( OpenDialog1->Execute() )
    { fHTML = OpenDialog1->FileName;
      ShellExecute(Form1->Handle, "open", fHTML.c_str(), NULL,NULL, SW_SHOWNORMAL);
      //ShellExecute(handle, "open", path_to_folder, NULL, NULL, SW_SHOW);
    }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::bitnShowRTFClick(TObject *Sender)
{
  if ( FileExists(fRTF) )
    ShellExecute(Form1->Handle,"open",fRTF.c_str(),NULL,NULL,SW_SHOWNORMAL);
  else
    ShowMessage("Please specify file first!");  
}
//---------------------------------------------------------------------------
void __fastcall TForm1::bitnSaveRTFClick(TObject *Sender)
{
  SaveDialog1->Filter = "*.rtf|*.rtf";
  SaveDialog1->DefaultExt = fRTF;

  if ( SaveDialog1->Execute() )
    { if ( FileExists(SaveDialog1->FileName) )
        { int ans = MessageDlg(SaveDialog1->FileName+" exists, overwirte it?",
                           mtWarning, TMsgDlgButtons() << mbYes << mbNo, 0);
          if ( ans==mrNo ) return;
        }
      RichEdit1->PlainText = false;
      RichEdit1->Lines->SaveToFile(SaveDialog1->FileName);
      ShowMessage("File has saved!");
      fRTF = SaveDialog1->FileName;
    }        
}
//---------------------------------------------------------------------------
